name: samba-ad-dc

services:
  dc-0:
    build:
      context: .
      dockerfile: Dockerfile.alpine
    container_name: dc-0
    volumes:
      - /etc/localtime:/etc/localtime:ro
      - dc-0:/var/lib/samba
      - dc-0:/etc/external
    environment:
      DOMAIN: "example.net"
      ADMIN_USER: "Administrator"
      ADMIN_PASS: "Test^123456#"
      HOST_IP: "10.0.0.10"
      HOST_NETWORK: "10.0.0.0/24"
      INSECURELDAP: "true"
      DNS_BACKEND: "BIND9_DLZ"
    ## Enable this section if you want to use the dc on the local network
    # ports:
      # - 53:53
      # - 53:53/udp
      # - 88:88
      # - 88:88/udp
      # - 135:135
      # - 137-138:137-138/udp
      # - 139:139
      # - 389:389
      # - 389:389/udp
      # - 445:445
      # - 464:464
      # - 464:464/udp
      # - 636:636
      # - 1024-1044:1024-1044
      # - 3268-3269:3268-3269
      ## This mapping will fail in most cases, so disabled by default
      # - 49152-65535:49152-65535
    dns_search:
      - example.net
    dns:
      - 10.0.0.10
      - 127.0.0.1
    hostname: dc-0
    cap_add:
      - NET_ADMIN
      - SYS_TIME
    devices:
      - /dev/net/tun
    privileged: true
    restart: always
    networks:
      samba:
        ipv4_address: 10.0.0.10
  dc-1:
    build:
      context: .
      dockerfile: Dockerfile.alpine
    container_name: dc-1
    volumes:
      - /etc/localtime:/etc/localtime:ro
      - dc-1:/var/lib/samba
      - dc-1:/etc/external
    environment:
      DOMAIN: "example.net"
      ADMIN_USER: "Administrator"
      ADMIN_PASS: "Test^123456#"
      HOST_IP: "10.0.0.11"
      HOST_NETWORK: "10.0.0.0/24"
      INSECURELDAP: "true"
      DNS_BACKEND: "BIND9_DLZ"
      JOIN: "true"
    dns_search:
      - example.net
    dns:
      - 10.0.0.10
      - 127.0.0.1
    hostname: dc-1
    cap_add:
      - NET_ADMIN
      - SYS_TIME
    devices:
      - /dev/net/tun
    privileged: true
    restart: always
    networks:
      samba:
        ipv4_address: 10.0.0.11

  debug:
    image: ideaplexus/debug
    container_name: debug
    dns_search:
      - example.net
    dns:
      - 10.0.0.10
      - 10.0.0.11
    networks:
      samba:
        ipv4_address: 10.0.0.20

volumes:
  dc-0:
  dc-1:

networks:
  samba:
    driver: bridge
    ipam:
        driver: default
        config:
            - subnet: 10.0.0.0/24
              gateway: 10.0.0.1